"use strict";

function _typeof(obj) { "@babel/helpers - typeof"; return _typeof = "function" == typeof Symbol && "symbol" == typeof Symbol.iterator ? function (obj) { return typeof obj; } : function (obj) { return obj && "function" == typeof Symbol && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }, _typeof(obj); }
Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.ViewDocumentComponent = void 0;
var _react = _interopRequireWildcard(require("react"));
var _reactBootstrap = require("react-bootstrap");
var _terminusdbDocumentsUi = require("@terminusdb/terminusdb-documents-ui");
var CONST = _interopRequireWildcard(require("./components/constants"));
var _ViewFramesButton = require("./components/ViewFramesButton");
var _CloseButton = require("./components/CloseButton");
var _JsonFrameViewer = require("./components/JsonFrameViewer");
var _ToggleJsonAndFormControl = require("./components/ToggleJsonAndFormControl");
var _ViewDocumentFrames = require("./components/ViewDocumentFrames");
var _CopyButton = require("./components/CopyButton");
var _ri = require("react-icons/ri");
var _TraverseDocumentLinks = require("./components/TraverseDocumentLinks");
var _SelectLanguageComponent = require("./components/SelectLanguageComponent");
var _utils = require("./utils");
var _ViewDocumentHistoryButton = require("./components/ViewDocumentHistoryButton");
var _ViewDocumentHistory = require("./components/ViewDocumentHistory");
var _ai = require("react-icons/ai");
var _Navbar = _interopRequireDefault(require("react-bootstrap/Navbar"));
var _Dropdown = _interopRequireDefault(require("react-bootstrap/Dropdown"));
function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }
function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }
function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") { return { "default": obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj["default"] = obj; if (cache) { cache.set(obj, newObj); } return newObj; }
function _slicedToArray(arr, i) { return _arrayWithHoles(arr) || _iterableToArrayLimit(arr, i) || _unsupportedIterableToArray(arr, i) || _nonIterableRest(); }
function _nonIterableRest() { throw new TypeError("Invalid attempt to destructure non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); }
function _unsupportedIterableToArray(o, minLen) { if (!o) return; if (typeof o === "string") return _arrayLikeToArray(o, minLen); var n = Object.prototype.toString.call(o).slice(8, -1); if (n === "Object" && o.constructor) n = o.constructor.name; if (n === "Map" || n === "Set") return Array.from(o); if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)) return _arrayLikeToArray(o, minLen); }
function _arrayLikeToArray(arr, len) { if (len == null || len > arr.length) len = arr.length; for (var i = 0, arr2 = new Array(len); i < len; i++) arr2[i] = arr[i]; return arr2; }
function _iterableToArrayLimit(arr, i) { var _i = null == arr ? null : "undefined" != typeof Symbol && arr[Symbol.iterator] || arr["@@iterator"]; if (null != _i) { var _s, _e, _x, _r, _arr = [], _n = !0, _d = !1; try { if (_x = (_i = _i.call(arr)).next, 0 === i) { if (Object(_i) !== _i) return; _n = !1; } else for (; !(_n = (_s = _x.call(_i)).done) && (_arr.push(_s.value), _arr.length !== i); _n = !0); } catch (err) { _d = !0, _e = err; } finally { try { if (!_n && null != _i["return"] && (_r = _i["return"](), Object(_r) !== _r)) return; } finally { if (_d) throw _e; } } return _arr; } }
function _arrayWithHoles(arr) { if (Array.isArray(arr)) return arr; } //import "terminusdb__darkly.css"
var DisplayDocumentID = function DisplayDocumentID(_ref) {
  var documentID = _ref.documentID,
    size = _ref.size;
  return /*#__PURE__*/_react["default"].createElement("div", {
    className: "col-md-".concat(size)
  }, /*#__PURE__*/_react["default"].createElement("strong", {
    className: "text-success"
  }, /*#__PURE__*/_react["default"].createElement("span", {
    className: "mr-1 h6 fst-italic"
  }, CONST.VIEW_DOCUMENT, ":"), /*#__PURE__*/_react["default"].createElement("span", {
    className: "fw-bolder h6"
  }, " ", (0, _utils.trimID)(documentID), " ")), /*#__PURE__*/_react["default"].createElement(_CopyButton.CopyButton, {
    text: "".concat(documentID),
    title: "Copy Document ID"
  }));
};

// we have to fix traversedocklinek
var ViewDocumentComponent = function ViewDocumentComponent(_ref2) {
  var type = _ref2.type,
    getDocumentById = _ref2.getDocumentById,
    documentJson = _ref2.documentJson,
    frames = _ref2.frames,
    closeButtonClick = _ref2.closeButtonClick,
    documentID = _ref2.documentID,
    deleteDocument = _ref2.deleteDocument,
    editDocument = _ref2.editDocument,
    history = _ref2.history,
    diffObject = _ref2.diffObject,
    setDiffCommitObject = _ref2.setDiffCommitObject,
    changeHistoryPage = _ref2.changeHistoryPage,
    startHistory = _ref2.startHistory;
  var _useState = (0, _react.useState)(CONST.FORM_VIEW),
    _useState2 = _slicedToArray(_useState, 2),
    view = _useState2[0],
    setView = _useState2[1];
  var _useState3 = (0, _react.useState)(false),
    _useState4 = _slicedToArray(_useState3, 2),
    clicked = _useState4[0],
    setClicked = _useState4[1];
  var _useState5 = (0, _react.useState)(false),
    _useState6 = _slicedToArray(_useState5, 2),
    selectedLanguage = _useState6[0],
    setSelectedLanguage = _useState6[1];
  var _useState7 = (0, _react.useState)({
      frames: false,
      history: false
    }),
    _useState8 = _slicedToArray(_useState7, 2),
    showInfo = _useState8[0],
    setShowInfo = _useState8[1];
  function handleTraverse(documentID) {
    (0, _TraverseDocumentLinks.onTraverse)(documentID, setClicked);
  }
  return /*#__PURE__*/_react["default"].createElement("div", {
    className: "w-100 d-flex"
  }, clicked && /*#__PURE__*/_react["default"].createElement(_TraverseDocumentLinks.TraverseDocumentLinks, {
    getDocumentById: getDocumentById,
    clicked: clicked,
    frames: frames,
    show: clicked !== false,
    onHide: function onHide() {
      return setClicked(false);
    }
  }), /*#__PURE__*/_react["default"].createElement(_reactBootstrap.Card, {
    className: "bg-dark flex-grow-1 ".concat((0, _utils.getCardWidth)(showInfo))
  }, /*#__PURE__*/_react["default"].createElement(_reactBootstrap.Card.Header, {
    className: "justify-content-between d-flex w-100 text-break"
  }, !(0, _utils.ifInfoOpen)(showInfo) && /*#__PURE__*/_react["default"].createElement(_reactBootstrap.Stack, {
    direction: "horizontal",
    gap: 2,
    className: "w-100"
  }, /*#__PURE__*/_react["default"].createElement(DisplayDocumentID, {
    documentID: documentID,
    size: 6
  }), /*#__PURE__*/_react["default"].createElement(_ViewFramesButton.ViewFramesButton, {
    setShowInfo: setShowInfo
  }), /*#__PURE__*/_react["default"].createElement(_ViewDocumentHistoryButton.ViewDocumentHistoryButton, {
    setShowInfo: setShowInfo
  }), /*#__PURE__*/_react["default"].createElement(_SelectLanguageComponent.LanguageSelectComponent, {
    frame: frames,
    setSelectedLanguage: setSelectedLanguage
  }), /*#__PURE__*/_react["default"].createElement(_ToggleJsonAndFormControl.ToggleJsonAndFormControl, {
    onClick: setView
  }), /*#__PURE__*/_react["default"].createElement("div", {
    className: "d-flex"
  }, /*#__PURE__*/_react["default"].createElement(_reactBootstrap.Button, {
    variant: "light",
    type: "button",
    title: "Edit Document",
    onClick: editDocument,
    className: "btn-sm btn d-flex text-dark mr-2"
  }, "Edit"), /*#__PURE__*/_react["default"].createElement(_reactBootstrap.Button, {
    variant: "danger",
    style: CONST.TOOLBAR_BUTTON_STYLES,
    type: "button",
    title: "Delete Document",
    onClick: deleteDocument,
    className: "btn-sm btn text-gray"
  }, /*#__PURE__*/_react["default"].createElement(_ri.RiDeleteBin7Line, {
    className: " mb-1"
  }))), /*#__PURE__*/_react["default"].createElement(_CloseButton.CloseButton, {
    type: type,
    onClick: closeButtonClick
  })), (0, _utils.ifInfoOpen)(showInfo) && /*#__PURE__*/_react["default"].createElement(_react["default"].Fragment, null, /*#__PURE__*/_react["default"].createElement(DisplayDocumentID, {
    documentID: documentID,
    size: 10
  }), /*#__PURE__*/_react["default"].createElement(_Dropdown["default"], null, /*#__PURE__*/_react["default"].createElement(_Dropdown["default"].Toggle, {
    variant: "transparent",
    id: "dropdown-basic",
    className: "border border-dark"
  }, /*#__PURE__*/_react["default"].createElement(_ai.AiOutlineMenu, null)), /*#__PURE__*/_react["default"].createElement(_Dropdown["default"].Menu, null, /*#__PURE__*/_react["default"].createElement(_Dropdown["default"].Item, {
    onClick: editDocument,
    title: "Edit Document"
  }, "Edit"), /*#__PURE__*/_react["default"].createElement(_Dropdown["default"].Item, {
    onClick: function onClick(e) {
      return setShowInfo({
        frames: Date.now(),
        history: false
      });
    },
    title: "View Frames"
  }, "View Frames"), /*#__PURE__*/_react["default"].createElement(_Dropdown["default"].Item, {
    onClick: function onClick(e) {
      return setShowInfo({
        frames: false,
        history: Date.now()
      });
    },
    title: "View History"
  }, "View History"), /*#__PURE__*/_react["default"].createElement(_Dropdown["default"].Item, null, /*#__PURE__*/_react["default"].createElement(_SelectLanguageComponent.LanguageSelectComponent, {
    frame: frames,
    setSelectedLanguage: setSelectedLanguage
  })), /*#__PURE__*/_react["default"].createElement(_Dropdown["default"].Item, {
    className: "d-table-cell"
  }, /*#__PURE__*/_react["default"].createElement(_ToggleJsonAndFormControl.ToggleJsonAndFormControl, {
    onClick: setView
  })), /*#__PURE__*/_react["default"].createElement(_Dropdown["default"].Divider, null), /*#__PURE__*/_react["default"].createElement(_Dropdown["default"].Item, {
    title: "Delete Document",
    onClick: deleteDocument
  }, "Delete"))))), /*#__PURE__*/_react["default"].createElement(_reactBootstrap.Card.Body, {
    className: "text-break"
  }, view === CONST.JSON_VIEW && /*#__PURE__*/_react["default"].createElement(_JsonFrameViewer.JsonFrameViewer, {
    jsonData: documentJson,
    mode: CONST.VIEW_DOCUMENT
  }), view === CONST.FORM_VIEW && /*#__PURE__*/_react["default"].createElement(_terminusdbDocumentsUi.FrameViewer, {
    frame: frames,
    type: type,
    mode: CONST.VIEW_DOCUMENT,
    formData: documentJson,
    language: selectedLanguage,
    hideSubmit: true,
    onTraverse: handleTraverse
  }))), /*#__PURE__*/_react["default"].createElement(_ViewDocumentFrames.ViewDocumentFrames, {
    type: type,
    documentFrame: frames[type] || {},
    showInfo: showInfo,
    setShowInfo: setShowInfo
  }), /*#__PURE__*/_react["default"].createElement(_ViewDocumentHistory.ViewDocumentHistory, {
    setShowInfo: setShowInfo,
    showInfo: showInfo,
    frames: frames,
    diffObject: diffObject,
    setDiffCommitObject: setDiffCommitObject,
    history: history,
    startHistory: startHistory,
    changeHistoryPage: changeHistoryPage,
    type: type,
    documentID: documentID
  }));
};
exports.ViewDocumentComponent = ViewDocumentComponent;