"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.DocumentDiffView = void 0;
var _react = _interopRequireDefault(require("react"));
var _terminusdbDocumentsUi = require("@terminusdb/terminusdb-documents-ui");
var _Stack = _interopRequireDefault(require("react-bootstrap/Stack"));
var _utils = require("../utils");
var _bi = require("react-icons/bi");
function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }
var Header = function Header(_ref) {
  var compareChecked = _ref.compareChecked;
  return /*#__PURE__*/_react["default"].createElement(_Stack["default"], {
    direction: "horizontal"
  }, /*#__PURE__*/_react["default"].createElement(_Stack["default"], {
    direction: "horizontal",
    gap: 2
  }, /*#__PURE__*/_react["default"].createElement(_bi.BiGitCommit, null), /*#__PURE__*/_react["default"].createElement("label", {
    className: "control-label w-100"
  }, compareChecked.identifier)), /*#__PURE__*/_react["default"].createElement(_Stack["default"], {
    direction: "horizontal",
    gap: 2,
    className: "ms-auto"
  }, /*#__PURE__*/_react["default"].createElement(_bi.BiTime, {
    className: "mb-1"
  }), /*#__PURE__*/_react["default"].createElement("label", {
    className: "w-100"
  }, (0, _utils.getFormattedTime)(compareChecked.timestamp))));
};
var DocumentDiffView = function DocumentDiffView(_ref2) {
  var diffObject = _ref2.diffObject,
    frames = _ref2.frames,
    type = _ref2.type,
    compareChecked = _ref2.compareChecked;
  return /*#__PURE__*/_react["default"].createElement(_terminusdbDocumentsUi.DiffViewer, {
    oldValue: diffObject.originalValue,
    newValue: diffObject.changedValue,
    oldValueHeader: /*#__PURE__*/_react["default"].createElement(Header, {
      compareChecked: compareChecked.curr
    }),
    newValueHeader: /*#__PURE__*/_react["default"].createElement(Header, {
      compareChecked: compareChecked.prev
    }),
    frame: frames
    //onTraverse={handleTraverse}
    ,
    type: type,
    diffPatch: diffObject.diff
  });
};
exports.DocumentDiffView = DocumentDiffView;