"use strict";

function _typeof(obj) { "@babel/helpers - typeof"; return _typeof = "function" == typeof Symbol && "symbol" == typeof Symbol.iterator ? function (obj) { return typeof obj; } : function (obj) { return obj && "function" == typeof Symbol && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }, _typeof(obj); }
Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.ViewDocumentHistory = void 0;
var _react = _interopRequireWildcard(require("react"));
var _reactBootstrap = require("react-bootstrap");
var _DocumentDiffView = require("./DocumentDiffView");
var _utils = require("../utils");
var _infoCloseButton = require("./infoCloseButton");
var _Modal = _interopRequireDefault(require("react-bootstrap/Modal"));
var _Row = _interopRequireDefault(require("react-bootstrap/Row"));
var _Col = _interopRequireDefault(require("react-bootstrap/Col"));
var _Pagination = _interopRequireDefault(require("react-bootstrap/Pagination"));
var _bi = require("react-icons/bi");
var _RadioButtonControllers = require("./RadioButtonControllers");
var _OverlayTrigger = _interopRequireDefault(require("react-bootstrap/OverlayTrigger"));
var _Tooltip = _interopRequireDefault(require("react-bootstrap/Tooltip"));
function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }
function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }
function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") { return { "default": obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj["default"] = obj; if (cache) { cache.set(obj, newObj); } return newObj; }
function _slicedToArray(arr, i) { return _arrayWithHoles(arr) || _iterableToArrayLimit(arr, i) || _unsupportedIterableToArray(arr, i) || _nonIterableRest(); }
function _nonIterableRest() { throw new TypeError("Invalid attempt to destructure non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); }
function _unsupportedIterableToArray(o, minLen) { if (!o) return; if (typeof o === "string") return _arrayLikeToArray(o, minLen); var n = Object.prototype.toString.call(o).slice(8, -1); if (n === "Object" && o.constructor) n = o.constructor.name; if (n === "Map" || n === "Set") return Array.from(o); if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)) return _arrayLikeToArray(o, minLen); }
function _arrayLikeToArray(arr, len) { if (len == null || len > arr.length) len = arr.length; for (var i = 0, arr2 = new Array(len); i < len; i++) arr2[i] = arr[i]; return arr2; }
function _iterableToArrayLimit(arr, i) { var _i = null == arr ? null : "undefined" != typeof Symbol && arr[Symbol.iterator] || arr["@@iterator"]; if (null != _i) { var _s, _e, _x, _r, _arr = [], _n = !0, _d = !1; try { if (_x = (_i = _i.call(arr)).next, 0 === i) { if (Object(_i) !== _i) return; _n = !1; } else for (; !(_n = (_s = _x.call(_i)).done) && (_arr.push(_s.value), _arr.length !== i); _n = !0); } catch (err) { _d = !0, _e = err; } finally { try { if (!_n && null != _i["return"] && (_r = _i["return"](), Object(_r) !== _r)) return; } finally { if (_d) throw _e; } } return _arr; } }
function _arrayWithHoles(arr) { if (Array.isArray(arr)) return arr; }
var DisplayHistoryDocumentID = function DisplayHistoryDocumentID(_ref) {
  var documentID = _ref.documentID,
    title = _ref.title;
  return /*#__PURE__*/_react["default"].createElement("div", null, /*#__PURE__*/_react["default"].createElement("strong", {
    className: "text-light"
  }, /*#__PURE__*/_react["default"].createElement("span", {
    className: "mr-1 h6 fst-italic"
  }, title, ": "), documentID && /*#__PURE__*/_react["default"].createElement("span", {
    className: "fw-bolder h6 text-success"
  }, " ", documentID, " ")));
};
var DiffViewModal = function DiffViewModal(_ref2) {
  var showDiff = _ref2.showDiff,
    setShowDiff = _ref2.setShowDiff,
    compareChecked = _ref2.compareChecked,
    diffObject = _ref2.diffObject,
    frames = _ref2.frames,
    type = _ref2.type,
    documentID = _ref2.documentID;
  var handleClose = function handleClose() {
    return setShowDiff(false);
  };
  return /*#__PURE__*/_react["default"].createElement(_Modal["default"], {
    size: "xl",
    show: showDiff,
    onHide: handleClose,
    fullscreen: true
  }, /*#__PURE__*/_react["default"].createElement(_Modal["default"].Header, {
    closeButton: true
  }, /*#__PURE__*/_react["default"].createElement(DisplayHistoryDocumentID, {
    documentID: documentID,
    title: "Diff View between commits ".concat(compareChecked.curr.identifier, " | ").concat(compareChecked.prev.identifier)
  })), /*#__PURE__*/_react["default"].createElement(_Modal["default"].Body, {
    className: "p-5"
  }, /*#__PURE__*/_react["default"].createElement(DiffDetailedHeaderMessage, {
    compareChecked: compareChecked
  }), /*#__PURE__*/_react["default"].createElement(_DocumentDiffView.DocumentDiffView, {
    diffObject: diffObject,
    type: type,
    compareChecked: compareChecked,
    frames: frames
  })));
};
var DiffHeaderMessage = function DiffHeaderMessage(_ref3) {
  var compareChecked = _ref3.compareChecked;
  return /*#__PURE__*/_react["default"].createElement(_reactBootstrap.Stack, {
    direction: "vertical",
    className: "mb-3 w-100 text-center",
    gap: 1
  }, /*#__PURE__*/_react["default"].createElement("label", null, "Diff between"), /*#__PURE__*/_react["default"].createElement("label", {
    className: "control-label w-100 text-center"
  }, compareChecked.curr.identifier), /*#__PURE__*/_react["default"].createElement("div", {
    className: ""
  }, "&"), /*#__PURE__*/_react["default"].createElement("label", {
    className: "control-label w-100 text-center"
  }, compareChecked.prev.identifier));
};
var DisplayInfoPerVersion = function DisplayInfoPerVersion(_ref4) {
  var compareChecked = _ref4.compareChecked;
  return /*#__PURE__*/_react["default"].createElement(_react["default"].Fragment, null, /*#__PURE__*/_react["default"].createElement(_reactBootstrap.Stack, {
    direction: "horizontal",
    gap: 2,
    className: "ml-2"
  }, /*#__PURE__*/_react["default"].createElement(_bi.BiUser, null), /*#__PURE__*/_react["default"].createElement("label", {
    className: "text-white w-100"
  }, compareChecked.author)), /*#__PURE__*/_react["default"].createElement(_reactBootstrap.Stack, {
    direction: "horizontal",
    gap: 2,
    className: "ml-2"
  }, /*#__PURE__*/_react["default"].createElement(_bi.BiMessageDetail, null), /*#__PURE__*/_react["default"].createElement("label", {
    className: "text-white w-100"
  }, compareChecked.message)));
};
var DiffDetailedHeaderMessage = function DiffDetailedHeaderMessage(_ref5) {
  var compareChecked = _ref5.compareChecked;
  return /*#__PURE__*/_react["default"].createElement(_Row["default"], {
    className: "w-100 mb-3"
  }, /*#__PURE__*/_react["default"].createElement(_Col["default"], {
    md: 6
  }, /*#__PURE__*/_react["default"].createElement(DisplayInfoPerVersion, {
    compareChecked: compareChecked.curr
  })), /*#__PURE__*/_react["default"].createElement(_Col["default"], {
    md: 6
  }, /*#__PURE__*/_react["default"].createElement(DisplayInfoPerVersion, {
    compareChecked: compareChecked.prev
  })));
};
var DiffInformation = function DiffInformation(_ref6) {
  var compareChecked = _ref6.compareChecked,
    setShowDiff = _ref6.setShowDiff,
    setDiffCommitObject = _ref6.setDiffCommitObject;
  function handleViewDiff() {
    setDiffCommitObject({
      beforeVersion: compareChecked.prev.identifier,
      afterVersion: compareChecked.curr.identifier
    });
    setShowDiff(Date.now());
  }
  if (compareChecked.curr.identifier && compareChecked.prev.identifier) {
    return /*#__PURE__*/_react["default"].createElement(_reactBootstrap.Card, {
      border: "light",
      className: "p-2"
    }, /*#__PURE__*/_react["default"].createElement(_reactBootstrap.Stack, {
      className: "mb-3",
      gap: 3
    }, /*#__PURE__*/_react["default"].createElement(DiffHeaderMessage, {
      compareChecked: compareChecked
    }), /*#__PURE__*/_react["default"].createElement(_reactBootstrap.Button, {
      className: "btn btn-md bg-light text-dark",
      onClick: handleViewDiff
    }, "View Diff")));
  }
  return /*#__PURE__*/_react["default"].createElement("div", null);
};
var ErrorMessage = function ErrorMessage() {
  return "Something went wrong ... no history is available to display.";
};
var DisplayHistory = function DisplayHistory(_ref7) {
  var history = _ref7.history,
    setDiffCommitObject = _ref7.setDiffCommitObject,
    diffObject = _ref7.diffObject,
    frames = _ref7.frames,
    type = _ref7.type,
    changeHistoryPage = _ref7.changeHistoryPage,
    startHistory = _ref7.startHistory,
    documentID = _ref7.documentID;
  if (!Array.isArray(history)) return /*#__PURE__*/_react["default"].createElement(ErrorMessage, null);
  if (!history.length) return /*#__PURE__*/_react["default"].createElement(ErrorMessage, null);
  var _useState = (0, _react.useState)(false),
    _useState2 = _slicedToArray(_useState, 2),
    showDiff = _useState2[0],
    setShowDiff = _useState2[1];
  // first checked radio button is always the most recent commit
  var _useState3 = (0, _react.useState)({
      curr: false,
      prev: false
    }),
    _useState4 = _slicedToArray(_useState3, 2),
    compareChecked = _useState4[0],
    setCompareChecked = _useState4[1];
  var _useState5 = (0, _react.useState)(false),
    _useState6 = _slicedToArray(_useState5, 2),
    prevChecked = _useState6[0],
    setPrevChecked = _useState6[1];
  var _useState7 = (0, _react.useState)(Date.now()),
    _useState8 = _slicedToArray(_useState7, 2),
    refresh = _useState8[0],
    setRefresh = _useState8[1];
  var _useState9 = (0, _react.useState)(history),
    _useState10 = _slicedToArray(_useState9, 2),
    historyBuffer = _useState10[0],
    setHistoryBuffer = _useState10[1];
  (0, _react.useEffect)(function () {
    if (Array.isArray(history) && history.length) {
      setHistoryBuffer(history);
    }
  }, [history]);
  var elements = [],
    maxHistoryPerCall = 5,
    curr = "curr",
    prev = "prev";

  // function which handle's changes on click of radiobuttons
  function _handleChange(historyItem) {
    var checked = compareChecked;
    if (!prevChecked) {
      //checked.curr = historyItem.identifier
      checked.curr = historyItem;
      setPrevChecked(curr);
    } else if (prevChecked === curr) {
      //checked.prev = historyItem.identifier
      checked.prev = historyItem;
      setPrevChecked(prev);
    } else if (prevChecked === prev) {
      //checked.curr = historyItem.identifier
      checked.curr = historyItem;
      setPrevChecked(curr);
    }
    setCompareChecked(checked);
    setRefresh(Date.now());
  }
  var changePageCallNext = function changePageCallNext() {
    setHistoryBuffer([]); // reset this so as to disable nextActive button on every click to help pagination
    changeHistoryPage(startHistory + 5);
  };
  var changePageCallPrevious = function changePageCallPrevious() {
    changeHistoryPage(startHistory - 5);
  };

  //console.log("startHistory", startHistory)
  //console.log("history length", history.length)

  var prevActive = startHistory > 1 ? {
    onClick: changePageCallPrevious
  } : {
    active: false
  };
  //const nextActive = history.length > maxHistoryPerCall-1  ? { onClick: changePageCallNext } : { active: false }
  var nextActive = historyBuffer.length > 5 ? {
    onClick: changePageCallNext
  } : {
    onClick: function onClick() {}
  };
  var lastHistory = startHistory + Math.min(historyBuffer.length, maxHistoryPerCall);
  var page = Math.ceil(startHistory / maxHistoryPerCall);
  historyBuffer.map(function (historyItem, index) {
    var commitID = historyItem.identifier;
    elements.push( /*#__PURE__*/_react["default"].createElement(_reactBootstrap.Card, {
      key: commitID,
      className: "mb-4"
    }, /*#__PURE__*/_react["default"].createElement(_reactBootstrap.Card.Body, null, refresh && /*#__PURE__*/_react["default"].createElement(_RadioButtonControllers.RadioButtonControllers, {
      commitID: commitID,
      displayText: (0, _utils.getFormattedTime)(historyItem.timestamp),
      compareChecked: compareChecked,
      startHistory: startHistory,
      recentCommit: startHistory === index ? true : false,
      handleChange: function handleChange(e) {
        return _handleChange(historyItem);
      },
      setCompareChecked: setCompareChecked
    }), /*#__PURE__*/_react["default"].createElement(_reactBootstrap.Stack, {
      gap: 1,
      className: "text-light"
    }, /*#__PURE__*/_react["default"].createElement(_reactBootstrap.Stack, {
      direction: "horizontal",
      gap: 3
    }, " ", /*#__PURE__*/_react["default"].createElement(_bi.BiGitCommit, null), commitID), /*#__PURE__*/_react["default"].createElement(_reactBootstrap.Stack, {
      direction: "horizontal",
      gap: 3
    }, " ", /*#__PURE__*/_react["default"].createElement(_bi.BiUser, null), historyItem.author), /*#__PURE__*/_react["default"].createElement(_OverlayTrigger["default"], {
      key: "left",
      placement: "left",
      overlay: /*#__PURE__*/_react["default"].createElement(_Tooltip["default"], {
        id: "tooltip-".concat("left")
      }, historyItem.message)
    }, /*#__PURE__*/_react["default"].createElement(_reactBootstrap.Button, {
      variant: "secondary",
      className: "btn btn-sm fst-italic text-light"
    }, "Hover to view commit message"))))));
  });
  return /*#__PURE__*/_react["default"].createElement(_reactBootstrap.Stack, {
    gap: 2
  }, /*#__PURE__*/_react["default"].createElement(DiffInformation, {
    compareChecked: compareChecked,
    setShowDiff: setShowDiff,
    setDiffCommitObject: setDiffCommitObject
  }), /*#__PURE__*/_react["default"].createElement(_Pagination["default"], {
    size: "ls",
    className: "justify-content-center"
  }, /*#__PURE__*/_react["default"].createElement(_Pagination["default"].Prev, prevActive), /*#__PURE__*/_react["default"].createElement(_Pagination["default"].Item, {
    className: "history__page__item"
  }, "Page ".concat(page + 1, " -- History from ").concat(startHistory + 1, " to ").concat(lastHistory)), /*#__PURE__*/_react["default"].createElement(_Pagination["default"].Next, nextActive)), /*#__PURE__*/_react["default"].createElement(DiffViewModal, {
    showDiff: showDiff,
    setShowDiff: setShowDiff,
    frames: frames,
    documentID: documentID,
    type: type,
    diffObject: diffObject,
    compareChecked: compareChecked
  }), elements);
};
var ViewDocumentHistory = function ViewDocumentHistory(_ref8) {
  var setShowInfo = _ref8.setShowInfo,
    showInfo = _ref8.showInfo,
    documentID = _ref8.documentID,
    history = _ref8.history,
    diffObject = _ref8.diffObject,
    setDiffCommitObject = _ref8.setDiffCommitObject,
    frames = _ref8.frames,
    type = _ref8.type,
    changeHistoryPage = _ref8.changeHistoryPage,
    startHistory = _ref8.startHistory;
  if (!showInfo.history) return /*#__PURE__*/_react["default"].createElement(_react["default"].Fragment, null);

  //console.log("got history", history)

  return /*#__PURE__*/_react["default"].createElement(_reactBootstrap.Card, {
    className: "tdb__frame__display ml-3",
    style: {
      width: "50%"
    }
  }, /*#__PURE__*/_react["default"].createElement(_reactBootstrap.Card.Header, null, /*#__PURE__*/_react["default"].createElement(_reactBootstrap.Stack, {
    direction: "horizontal"
  }, /*#__PURE__*/_react["default"].createElement(DisplayHistoryDocumentID, {
    title: "History"
  }), /*#__PURE__*/_react["default"].createElement(_infoCloseButton.CloseInfoButton, {
    setShowInfo: setShowInfo
  }))), /*#__PURE__*/_react["default"].createElement(_reactBootstrap.Card.Body, null, /*#__PURE__*/_react["default"].createElement(_reactBootstrap.Card.Text, {
    className: "text-light text-center"
  }, "Click on dates to compare between different versions ..."), /*#__PURE__*/_react["default"].createElement(DisplayHistory, {
    history: history,
    changeHistoryPage: changeHistoryPage,
    startHistory: startHistory,
    frames: frames,
    type: type,
    documentID: documentID,
    setDiffCommitObject: setDiffCommitObject,
    diffObject: diffObject
  })));
};
exports.ViewDocumentHistory = ViewDocumentHistory;